package com.redhat.thermostat.tools.eclipse.plugin;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ResourcesPlugin;

public class ProjectFinder {

    // TODO replace with j.u.f.Predicate
    public static interface Criteria {
        public boolean matches(IProject project);
    }

    public List<IProject> find(Criteria criteria) {
        List<IProject> result = new ArrayList<>();

        IProject[] projects = ResourcesPlugin.getWorkspace().getRoot().getProjects();
        for (IProject project : projects) {
           if (criteria.matches(project)) {
               result.add(project);
           }
        }
        return result;
    }

    public List<String> findProjectNames(Criteria criteria) {
        List<String> result = new ArrayList<>();

        IProject[] projects = ResourcesPlugin.getWorkspace().getRoot().getProjects();
        for (IProject project : projects) {
           if (criteria.matches(project)) {
               result.add(project.getName());
           }
        }
        return result;
    }
}
