package com.redhat.thermostat.tools.eclipse.plugin;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Enumeration;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

public class Unzipper {

    public void unzip(ZipFile zipFile, File targetDirectory) throws IOException {
        Enumeration<? extends ZipEntry> entries = zipFile.entries();
        while (entries.hasMoreElements()) {
            ZipEntry entry = entries.nextElement();

            if (entry.isDirectory()) {
                continue;
            }

            File targetFile = new File(targetDirectory, entry.getName());
            targetFile.getParentFile().mkdirs();

            copyStream(zipFile.getInputStream(entry), new FileOutputStream(targetFile));
        }
    }

    private void copyStream(InputStream input, OutputStream output) throws IOException {
        byte[] buffer = new byte[1024];
        try (InputStream in = new BufferedInputStream(input)) {
            try (OutputStream out = new BufferedOutputStream(output)) {
                int read = 0;
                while ((read = in.read(buffer)) != -1) {
                    out.write(buffer, 0, read);
                }
            }
        }
    }
}
